#if (__SUNPRO_CC)
#define typename
#endif

#include <iostream.h>
#include <fstream.h>
#include <vector.h>
#include <gen_rec_inters.h>

/* type of a rectangle */
struct Rectangle
{
  double x1, x2, y1, y2;
  Rectangle()
  {}
  Rectangle(double x_l, double x_h, double y_l, double y_h)
  : x1(x_l), x2(x_h), y1(y_l), y2(y_h)
  {}
};

/* input operator for  rectangle: */
istream &operator>> (istream &in, Rectangle& rec)
{
  in >> rec.x1 >> rec.y1 >> rec.x2 >> rec.y2;
  return in;
}

/* output operator for rectangle: */
ostream &operator<< (ostream &out, Rectangle const &rec)
{
  out << "(" << rec.x1 << "," << rec.y1 << ")==("
      << rec.x2 << "," << rec.y2 << ")";
  return out;
}

/* data accessors for rectangles */
struct lowXcoord { typedef double value_type; };
struct lowYcoord { typedef double value_type; };
struct highXcoord { typedef double value_type; };
struct highYcoord { typedef double value_type; };

/* the corresponding data accessing functions */
template <class It>
inline double get(lowXcoord da, It const &it) { return (*it). x1; }
template <class It>
inline double get(lowYcoord da, It const &it) { return (*it). y1; }
template <class It>
inline double get(highXcoord da, It const &it) { return (*it). x2; }
template <class It>
inline double get(highYcoord da, It const &it) { return (*it). y2; }


main(int argc, char *argv[])
{
    /* type definitions */
    typedef typename list<Rectangle>::iterator Rec_it;
    typedef GenRecInters< Rec_it, lowXcoord, lowYcoord, highXcoord, highYcoord>
	Rec_algo;
    typedef typename Rec_algo::Rectangle_it Recalgo_it;
    
    cout << "This program detects pairs of properly intersecting rectangles."
	 << endl << endl;
  
    /* read the input rectangles */
    list<Rectangle> rectangles;    
    cout << "Please enter the coordinates of lower left and upper right"
         << endl << "corner of the rectangles (ll x, ll y, ur x, ur y)."
         << endl << endl;
    Rectangle rectangle;
    while (cin >> rectangle)
        rectangles.push_back(rectangle);

    /* initialize the algorithm */
    cout << endl << "initializing..." << endl;
    Rec_algo my_recalgo(rectangles.begin(), rectangles.end());
    /* the sweep */
    cout << "sweeping..." << endl;
    do
    {
      Rec_algo::Algo_state state;
      switch ( state = my_recalgo.step() )
      {
      case Rec_algo::rectangle_start:
        {
          cout << " rectangle " << *my_recalgo.current()
               << " inserted in sls" << endl;
          Recalgo_it current = my_recalgo.begin();
          for ( ; !(current == my_recalgo.end()); ++current)
            cout << "  intersects rectangle " << **current << endl;
        }
        break;
      case Rec_algo::rectangle_end:
        cout << " rectangle " << *my_recalgo.current()
             << " deleted from sls" << endl;
        break;
      default:
        cout << " state of Iso_rect_inter = " << state << endl;
      }
    } while (my_recalgo.valid());
    cout << "done." << endl;
}
