#include <iostream.h>
#include <list.h>
#include <vector.h>
#include <oo_interval_tree.h>

/* input operator for an interval: */
istream &operator>> (istream &in, Interval<double>& interval)
{
    in >> interval.left >> interval.right;
    return in;
}

/* output operator for an interval: */
ostream &operator<< (ostream &out, Interval<double> const &interval)
{
    out << "(" << interval.left << ", " << interval.right << ")";
    return out;
}

main()
{
    cout << endl << "         Testing the interval tree" << endl << endl;
    
    /* type definitions */
    typedef OOIntervalTree<double, int> Interval_tree;
    typedef typename Interval_tree::Interval_ls Interval_ls;
    typedef typename Interval_tree::Interval_ls_it Interval_ls_it;
    typedef typename Interval_tree::Interval_position ID;
    
    /* read the input intervals */
    Interval_ls interval_ls;
    Interval<double> interval;
    cout << "Enter the endpoints of the intervals: " << endl <<
	"(enter an interval of length zero to mark the end of the input" <<
	" intervals)"<< endl;
    vector<Interval_ls_it> positions;
    while (cin >> interval && (interval.left != interval.right))
	positions.push_back(interval_ls.insert(interval_ls.end(), interval));
    
    /* output the read intervals */
    cout << "  Interval No.    " << "Interval" << "   Info" << endl;
    int i = 0;
    Interval_ls_it intervals_end = interval_ls.end();
    for (Interval_ls_it intervals_beg = interval_ls.begin();
	 intervals_beg != intervals_end; intervals_beg++)
	cout << "      " << i++ << "           " << *intervals_beg << endl;
    cout << endl;
      
    /* declare an object of type OOIntervalTree */
    Interval_tree interval_tree(interval_ls);
    ID *del_info = new ID[interval_ls.size()];

    /* update on and report from the interval tree */
    cout << "i-insert, d-delete, r-report and number of interval:" << endl;
    char c;    
    while (cin >> c)
    {
	cin >> i;
	switch (c)
	{
	    case 'i':
		{
		    int info;
		    cout << "inserting" << endl;
		    cin >> info;
		    del_info[i] = interval_tree.insert(positions[i], info);
		}
	    break;
	    case 'd':
		{
		    interval_tree.erase(del_info[i]);
		}
	    break;
	    case 'r':
		{
		    list<int> intersections;
		    interval_tree.report(positions[i], intersections);
		    list<int>::iterator end = intersections.end();
		    list<int>::iterator begin = intersections.begin();
		    for(; !(begin == end); ++begin)
			cout << *begin << endl;
		}
	    break;
	}
    }
    delete[] del_info;    
}
   
