#if (__SUNPRO_CC)
#define typename
#endif

#include <iostream.h>
#include <fstream.h>
#include <vector.h>
#include <oo_rec_inters.h>

/* input operator for a rectangle: */
istream &operator>> (istream &in, Rectangle<double>& rec)
{
    in >> rec.llx >> rec.lly >> rec.urx >> rec.ury;
    return in;
}

/* output operator for a rectangle: */
ostream &operator<< (ostream &out, Rectangle<double> const &rec)
{
    out << "(" << rec.llx << ", " << rec.lly << ") === (";
    out << rec.urx << ", " << rec.ury << ")";
    return out;
}

main(int argc, char *argv[])
{
    /* type definitions */
    typedef OORecInters<double> Rec_algo;
    typedef typename Rec_algo::Rectangle_ls Rec_ls;
    typedef typename Rec_algo::Rectangle_ls_it Rec_it;
    typedef typename Rec_algo::Graph My_graph;
    typedef typename My_graph::Node_it Node_it;
    typedef typename My_graph::Adj_edge_it Adj_edge_it;
        
    cout << "This program detects pairs of properly intersecting rectangles."
	 << endl << endl;
    
    /* read the input rectangles */
    Rec_ls rectangles;
    cout << "Please enter the coordinates of lower left and upper right"
         << endl << "corner of the rectangles (ll x, ll y, ur x, ur y)."
         << endl << endl;
    Rectangle<double> rectangle;
    while (cin >> rectangle)
        rectangles.push_back(rectangle);
    
    /* initialize the algorithm */
    cout << endl << "initializing..." << endl;
    Rec_algo my_recalgo(rectangles);

    /* the sweep */
    cout << "sweeping..." << endl;
    My_graph* graph = my_recalgo.run();
    cout <<"No. of nodes: " << graph->num_of_nodes() << endl
	 <<"No. of edges: " << graph->num_of_edges() << endl;
    Node_it node_current = graph->nodes_begin();
    Node_it node_end = graph->nodes_end();
    for (int i = 0; node_current != node_end; ++node_current, i++)
    {
	cout << "[" << i << ", " << (**node_current) << "]:";
    Adj_edge_it edge_current = graph->adj_edges_begin(node_current);
    Adj_edge_it edge_end = graph->adj_edges_end(node_current);
    for ( ; edge_current != edge_end; ++edge_current)
      cout << "[" << **graph->opposite(node_current,
                       graph->get_edge_it(edge_current))
           << "]";
    cout << endl;
  }
  cout << "done." << endl;
}   
    
