#ifndef STL_EXT
#define STL_EXT

#if (__SUNPRO_CC)
#define typename
#endif

// standard libraries
#include <iostream.h>
#include <strstream.h>

// STL
#include <vector.h>
#include <iterator.h>

template <class InputIt, class DA>
class member_access_it
{
public:
  typedef typename DA::value_type value_type;

  // constructors
  member_access_it()
  {}
  member_access_it(InputIt const &it, DA da = DA()): my_it(it), my_da(da)
  {}

  // public member functions
  member_access_it &operator++ ()
  {
    ++my_it;
    return *this;
  }
  value_type const operator* () { return get(my_da, *my_it);}
  bool operator== (member_access_it const &it) const
  {
    return my_it == it.my_it;
  }
  bool operator!= (member_access_it const &it) const
  {
    return !(my_it == it.my_it);
  }
  InputIt get_iterator()
  {
    return my_it;
  }
  DA get_da()
  {
    return my_da;
  }
private:
  InputIt my_it;
  DA my_da;
};


#ifdef __KCC
using namespace std;
#endif

#if defined(__GNUG__) && __GNU_MINOR__ < 7
template <class T>
int *distance_type(istream_iterator<T> const &)
{
  return 0;
}
template <class T>
input_iterator_tag iterator_category(istream_iterator<T> const &)
{
  return input_iterator_tag();
}
#endif

template <class Iterator, class Distance>
Distance intern_lower_distance(Iterator &beg, Iterator &end, Distance *,
                               output_iterator_tag const &)
{
  Distance dist(0);
  distance(beg, end, dist);
  return dist;
}

template <class Iterator, class Distance>
Distance intern_lower_distance(Iterator &beg, Iterator &end, Distance *,
                               forward_iterator_tag const &)
{
  Distance dist(0);
  distance(beg, end, dist);
  return dist;
}

template <class Iterator, class Distance>
Distance intern_lower_distance(Iterator &beg, Iterator &end, Distance *,
                               bidirectional_iterator_tag const &)
{
  Distance dist(0);
  distance(beg, end, dist);
  return dist;
}

template <class Iterator, class Distance>
Distance intern_lower_distance(Iterator &beg, Iterator &end, Distance *,
                               random_access_iterator_tag const &)
{
  Distance dist(0);
  distance(beg, end, dist);
  return dist;
}

template <class T, class Distance>
Distance intern_lower_distance(istream_iterator<T, Distance> &beg,
                               istream_iterator<T, Distance> &end,
                               Distance *, input_iterator_tag const &)
{
  return 0;
}

template <class Iterator>
int lower_distance(Iterator begin, Iterator const &end)
{
  // return intern_lower_distance(begin, end, distance_type(begin),
  //                             iterator_category(begin));
  int distance = 0;
  while (begin != end)
  {
    ++distance;
    ++begin;
  }
  return distance;
}

#endif
